require "modules.camera"
require "modules.metavec3d"
require "modules.matrix3x3"
require "modules.objects"


local k = type

function type(thing)
local t = k(thing)
if t == "table" then
	if k(thing.type) == "string" then
		return thing.type
	end
end
return t
end


centralscreenpos = vec(400,300,0)

--type = mytype
objects = {}

muhangles = vec(0,0,0)


function love.load()
   --love.graphics.setColor(255,255,255,255)
   love.graphics.setBackgroundColor(0,162,232)
local pos0 = vec(0,0,0)
local dir = vec(0,0,1)
mycamera = camera.new(pos0,dir,vec(-1,0,0))
--love.mouse.setGrab(true)

--table.insert(objects, cube.new(vec(0,0,10),2))

table.insert(objects, cube.new(vec(0,5,5),2))
end



function love.update(dt)
	local mx,my = love.mouse.getPosition()
	mx=(mx-400)/100
	my=(my-300)/100

	if mx~=0 or my~=0 then	
		muhangles = muhangles + vec(-my,-mx,0)  -- sen(theta) practically = theta
		muhangles.x = muhangles.x%(2*math.pi)
		muhangles.y = muhangles.y%(2*math.pi)
		muhangles.z = muhangles.z%(2*math.pi)
		mycamera:setrotation(muhangles)
		--print("muhangles:", muhangles)
		--print("mx,my:", mx,my)
		print(mycamera.position)
	end

	
	


	love.mouse.setPosition(centralscreenpos.x,centralscreenpos.y)


	if love.keyboard.isDown("w") then
		mycamera.position = mycamera.position + dt*mycamera.forward
	end
	if love.keyboard.isDown("a") then
		mycamera.position = mycamera.position - dt*mycamera.right
	end
	if love.keyboard.isDown("s") then
		mycamera.position = mycamera.position - dt*mycamera.forward
	end
	if love.keyboard.isDown("d") then
		mycamera.position = mycamera.position + dt*mycamera.right
	end

	if love.keyboard.isDown("u") then
		mycamera.position = mycamera.position + dt*mycamera.up
	end
	if love.keyboard.isDown("j") then
		mycamera.position = mycamera.position - dt*mycamera.up
	end

end

function love.keypressed(key)
	if key == "tab" then
		local state = not love.mouse.isGrabbed()   -- the opposite of whatever it currently is
      		love.mouse.setGrab(state)
	elseif key == "escape" then
		love.quit()
   	end
end


function love.draw()

for k,v in pairs(objects) do
	--if isincone(v.position) then
	if (v.position - mycamera.position)*mycamera.forward > 0 then
		vertix = {}
		--[[for x=1,#v.vertices do
			local d = mycamera:from3dto2d(v.vertices[x])
			print(d)
			table.insert(vertix, d)
		end]]
		
		k=40
		local tabs = {}
		for x=1,#v.faces do
			local tab = {}
			local vecsum = vec(0,0,0)
			for y=1,#v.faces[x] do
				local point = mycamera:from3dto2d(v.faces[x][y])
				table.insert(tab, point)
				vecsum = vecsum + v.faces[x][y]-mycamera.position
			end
			tab.d = ((1/4)*vecsum):magnitude()		-- a media dos pontos eh um ponto no centro
			table.insert(tabs,tab)
			--love.graphics.polygon("fill", leunpack(tab))
			--drawquad(tab)
		end
		
		table.sort(tabs, function (a,b) return a.d > b.d end)
		
		for x=1,#tabs do
			love.graphics.setColor(255-x*k,255-x*k,255-x*k,255)
			love.graphics.polygon("fill", leunpack(tabs[x]))
		end
	end
end

end


function drawquad (vertices)
love.graphics.polygon("fill", leunpack({vertices[1],vertices[2],vertices[3]}))
love.graphics.polygon("fill", leunpack({vertices[3],vertices[4],vertices[1]}))
end


function leunpack(vertices)
local myvert = {}
for x=1,#vertices do
table.insert(myvert, vertices[x].x)
table.insert(myvert, vertices[x].y)
end
return myvert
end


